import { GemId } from './format/gemStats';
import { Stat } from './format/stats';
import { Options as TextToStatsOptions } from './format/textToStats';
import { StatLocaleDatas } from './types/StatDescription';
export declare enum Fallback {
    throw = 0,
    id = 1,
    skip = 2,
}
export declare type Options = {
    datas: StatLocaleDatas;
    fallback: Fallback;
    start_file: string;
};
export default class Format {
    private options;
    configure(options: Partial<Options>): void;
    stats(stats: Stat[]): string[];
    gemStats(gem_id: GemId, stats: Stat[]): string[];
    groupMods(mods: Stat[][]): string;
    textToStats(text: string, options?: Partial<TextToStatsOptions>): IterableIterator<Stat[]>;
}
