var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
import { inverseFactory } from '../localize/formatters';
import { asRegexp, matchesTranslation } from '../translate';
import { deterministicValueForMatcher } from '../util/symbolicStats';
import { getDescriptions } from './util';
/**
 * finds every stat or list of stats that could produce this text with its values
 *
 * use {textToStatsSingle} if you just want the first match
 * use {textToStatsArray} if you want the generator values as an array
 *
 * @param text the stat text
 * @param options see type definition
 */
export default function textToStats(text, options) {
    if (options === void 0) { options = {}; }
    var _a, datas, _b, start_file, _c, _d, descriptions, _e, _f, description, _loop_1, _g, _h, translation, e_1_1, e_2_1, e_3_1, e_3, _j, e_2, _k, e_1, _l;
    return __generator(this, function (_m) {
        switch (_m.label) {
            case 0:
                _a = options.datas, datas = _a === void 0 ? {} : _a, _b = options.start_file, start_file = _b === void 0 ? 'stat_descriptions' : _b;
                _m.label = 1;
            case 1:
                _m.trys.push([1, 18, 19, 20]);
                _c = __values(getDescriptions(datas, start_file)), _d = _c.next();
                _m.label = 2;
            case 2:
                if (!!_d.done) return [3 /*break*/, 17];
                descriptions = _d.value;
                _m.label = 3;
            case 3:
                _m.trys.push([3, 14, 15, 16]);
                _e = __values(Object.values(descriptions)), _f = _e.next();
                _m.label = 4;
            case 4:
                if (!!_f.done) return [3 /*break*/, 13];
                description = _f.value;
                if (description.no_description) {
                    return [3 /*break*/, 12];
                }
                _loop_1 = function (translation) {
                    var regexp, match, stats;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                regexp = asRegexp(translation);
                                match = regexp.match(text);
                                if (!(match !== null)) return [3 /*break*/, 2];
                                stats = description.stats.map(function (stat_id, i) {
                                    // arguments are 1-based
                                    var arg_index = String(i + 1);
                                    var matched_value = match[arg_index];
                                    var matcher = translation.matchers[i];
                                    var value = Number.NaN;
                                    if (matched_value !== undefined) {
                                        var formatter = translation.formatters
                                            .filter(function (f) { return typeof f !== 'string'; })
                                            .find(function (_a) {
                                            var arg = _a.arg;
                                            return String(arg) === arg_index;
                                        });
                                        if (formatter === undefined) {
                                            value = +matched_value;
                                        }
                                        else {
                                            value = inverseFactory(formatter.id)(matched_value);
                                            if (Number.isNaN(value)) {
                                                // otherwise the return value would be equal to the case
                                                // where the value is not contained in the text
                                                throw new Error('int parsing returned NaN');
                                            }
                                        }
                                    }
                                    else if (typeof matcher === 'number') {
                                        // value is not contained in the text
                                        // guess (deterministically) a value for this instance
                                        // that would have produced that translation
                                        value = deterministicValueForMatcher(translation.matchers[i]);
                                    }
                                    return {
                                        id: stat_id,
                                        value: value
                                    };
                                });
                                if (!matchesTranslation(translation, stats.map(function (_a) {
                                    var value = _a.value;
                                    return value;
                                }))) return [3 /*break*/, 2];
                                return [4 /*yield*/, stats];
                            case 1:
                                _a.sent();
                                _a.label = 2;
                            case 2: return [2 /*return*/];
                        }
                    });
                };
                _m.label = 5;
            case 5:
                _m.trys.push([5, 10, 11, 12]);
                _g = __values(description.translations), _h = _g.next();
                _m.label = 6;
            case 6:
                if (!!_h.done) return [3 /*break*/, 9];
                translation = _h.value;
                return [5 /*yield**/, _loop_1(translation)];
            case 7:
                _m.sent();
                _m.label = 8;
            case 8:
                _h = _g.next();
                return [3 /*break*/, 6];
            case 9: return [3 /*break*/, 12];
            case 10:
                e_1_1 = _m.sent();
                e_1 = { error: e_1_1 };
                return [3 /*break*/, 12];
            case 11:
                try {
                    if (_h && !_h.done && (_l = _g.return)) _l.call(_g);
                }
                finally { if (e_1) throw e_1.error; }
                return [7 /*endfinally*/];
            case 12:
                _f = _e.next();
                return [3 /*break*/, 4];
            case 13: return [3 /*break*/, 16];
            case 14:
                e_2_1 = _m.sent();
                e_2 = { error: e_2_1 };
                return [3 /*break*/, 16];
            case 15:
                try {
                    if (_f && !_f.done && (_k = _e.return)) _k.call(_e);
                }
                finally { if (e_2) throw e_2.error; }
                return [7 /*endfinally*/];
            case 16:
                _d = _c.next();
                return [3 /*break*/, 2];
            case 17: return [3 /*break*/, 20];
            case 18:
                e_3_1 = _m.sent();
                e_3 = { error: e_3_1 };
                return [3 /*break*/, 20];
            case 19:
                try {
                    if (_d && !_d.done && (_j = _c.return)) _j.call(_c);
                }
                finally { if (e_3) throw e_3.error; }
                return [7 /*endfinally*/];
            case 20: return [2 /*return*/];
        }
    });
}
/**
 * @see {textToStats} as array
 *
 * @param text
 * @param options
 */
export function textToStatsArray(text, options) {
    if (options === void 0) { options = {}; }
    return Array.from(textToStats(text, options));
}
/**
 * only first match of  @see {textToStats} but throws if none was found
 *
 * @param text
 * @param options
 */
export function textToStatsFirst(text, options) {
    if (options === void 0) { options = {}; }
    var _a = textToStats(text, options).next(), done = _a.done, value = _a.value;
    if (done) {
        throw new Error('Could match a single stat');
    }
    return value;
}
