var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
import formatFactory from './formatters';
export function formatValues(values, options) {
    var formatters = options.formatters;
    if (formatters === undefined) {
        throw new Error('formatters not set');
    }
    var formatted = __spread(values);
    formatters.forEach(function (formatter, i) {
        if (typeof formatter !== 'string' && typeof formatter.arg === 'number') {
            // base_chance_to_freeze% is the only exception
            // see issues #25 and #33
            var offset = formatter.id === 'canonical_stat' &&
                formatters.includes('canonical_line')
                ? 0
                : -1;
            var target_param = values[+formatter.arg + offset];
            if (target_param !== undefined) {
                formatted[+formatter.arg - 1] = formatValue(target_param, {
                    formatter: formatter
                });
            }
            else {
                throw new Error("no param given for formatter '" + formatter.id + "'");
            }
        }
    });
    return formatted.map(function (value) {
        return typeof value === 'string'
            ? value
            : formatValue(value, { formatter: { id: 'id', arg: 1 } });
    });
}
export function formatValue(value, options) {
    var formatter = options.formatter;
    if (formatter === undefined) {
        throw new Error('no formatter given');
    }
    return String(formatFactory(formatter.id)(value));
}
